package runner;

import static org.junit.Assert.assertTrue;

import java.io.File;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

import org.apache.commons.io.FileUtils;
import org.junit.Test;

import com.intuit.karate.KarateOptions;
import com.intuit.karate.Results;
import com.intuit.karate.Runner;

import net.masterthought.cucumber.Configuration;
import net.masterthought.cucumber.ReportBuilder;

@KarateOptions(tags={"@test"})
public class TestRunner {

    @Test
    public void actTest() {
	Results results = Runner.parallel(getClass(), 10);
	generateReport(results.getReportDir());
	assertTrue(results.getErrorMessages(), results.getFailCount() == 0);
    }

    public static void generateReport(String karateOutputPath) {
	Collection<File> jsonFiles = FileUtils.listFiles(new File(karateOutputPath), new String[] { "json" }, true);
	List<String> jsonPaths = new ArrayList(jsonFiles.size());
	jsonFiles.forEach(file -> jsonPaths.add(file.getAbsolutePath()));
	Configuration config = new Configuration(new File("target"), "demo");
	ReportBuilder reportBuilder = new ReportBuilder(jsonPaths, config);
	reportBuilder.generateReports();
    }

}
